var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : new P(function (resolve) {
        resolve(result.value);
      }).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __generator = this && this.__generator || function (thisArg, body) {
  var _ = {
    label: 0,
    sent: function () {
      if (t[0] & 1) throw t[1];
      return t[1];
    },
    trys: [],
    ops: []
  },
      f,
      y,
      t,
      g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;

  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }

  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");

    while (_) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];

      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;

        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };

        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;

        case 7:
          op = _.ops.pop();

          _.trys.pop();

          continue;

        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }

          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }

          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }

          if (t && _.label < t[2]) {
            _.label = t[2];

            _.ops.push(op);

            break;
          }

          if (t[2]) _.ops.pop();

          _.trys.pop();

          continue;
      }

      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }

    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};

import * as React from "react";
import SFilter from "./comps/SFilter";
import STable from "./comps/STable";
import SModal from "./comps/SModal";
import { getList } from "./lib/api";
import { dealParams, dealRangePickerParams } from "./utils/params";
import { isObj } from "./utils/tool";
import verifyParams from "./lib/verifyParams";
import useColumns from "./hooks/useColumns";
import { compDidMount } from "./lifeCycleHooks/lifeCycle";
var useState = React.useState;
export default function SPage(props) {
  var _this = this;

  var url = props.url,
      filters = props.filters,
      tableColumns = props.tableColumns,
      searchHandler = props.searchHandler,
      _a = props.isDealRangePicker,
      isDealRangePicker = _a === void 0 ? true : _a,
      initialData = props.initialData,
      _b = props.initialSearch,
      initialSearch = _b === void 0 ? true : _b,
      _c = props.tableProps,
      tableProps = _c === void 0 ? {} : _c,
      rowKey = props.rowKey;
  tableProps["rowKey"] = rowKey;

  var _d = useState(initialData),
      formData = _d[0],
      setFormData = _d[1];

  var _e = useState(props.tableData),
      tableData = _e[0],
      setTableData = _e[1];

  var _f = useState(10),
      pageSize = _f[0],
      setPageSize = _f[1];

  var _g = useState(1),
      pageNum = _g[0],
      setPageNum = _g[1];

  var _h = useState(0),
      totalNum = _h[0],
      setTotalNum = _h[1];

  var _j = useState(null),
      modalChildren = _j[0],
      setModalChildren = _j[1];

  var _k = useState({}),
      modalProps = _k[0],
      setModalProps = _k[1];

  var _l = useState(false),
      modalVisible = _l[0],
      setModalVisible = _l[1];

  var _m = useState(false),
      searchLoading = _m[0],
      setSearchLoading = _m[1];

  var requiredParams = [];
  filters.forEach(function (_a) {
    var required = _a.required,
        key = _a.key;
    if (required) requiredParams.push(key);
  });

  var getTableList = function (opt) {
    return __awaiter(_this, void 0, void 0, function () {
      var _a, list, total_num;

      return __generator(this, function (_b) {
        switch (_b.label) {
          case 0:
            if (isDealRangePicker) opt = dealRangePickerParams(opt);
            setSearchLoading(true);
            _b.label = 1;

          case 1:
            _b.trys.push([1,, 3, 4]);

            return [4
            /*yield*/
            , getList(url, opt)];

          case 2:
            _a = _b.sent().data, list = _a.list, total_num = _a.total_num;
            setTotalNum(total_num);
            setTableData(list || []);
            return [3
            /*break*/
            , 4];

          case 3:
            setSearchLoading(false);
            return [7
            /*endfinally*/
            ];

          case 4:
            return [2
            /*return*/
            ];
        }
      });
    });
  };

  var _searchHandler = function () {
    var opt = formData;
    var handlerRes = searchHandler && searchHandler(opt);
    isObj(handlerRes) && (opt = handlerRes);
    opt = dealParams(opt);
    if (!verifyParams(opt, requiredParams)) return;
    setPageNum(1);
    return getTableList(__assign({}, opt, {
      page_size: pageSize,
      page_num: 1
    }));
  };

  var openModal = function (record, modalRender, modalProps) {
    if (modalProps === void 0) {
      modalProps = {};
    }

    setModalVisible(true);
    setModalChildren(modalRender && modalRender(record));
    setModalProps(modalProps);
  };

  var closeModal = function () {
    setModalVisible(false);
  };

  var pageChange = function (pageNum, pageSize) {
    setPageNum(pageNum);
    setPageSize(pageSize);
    getTableList(__assign({}, formData, {
      page_size: pageSize,
      page_num: pageNum
    }));
  };

  var columns = useColumns(filters, tableColumns, openModal);
  if (initialSearch) compDidMount(_searchHandler);
  return React.createElement("div", null, React.createElement(SFilter, __assign({
    updateFormData: setFormData,
    searchBtnHandler: _searchHandler,
    searchLoading: searchLoading
  }, props)), props.children, React.createElement(STable, {
    tableData: tableData,
    tableColumns: columns,
    tableProps: tableProps,
    pageChange: pageChange,
    pageSize: pageSize,
    pageNum: pageNum,
    totalNum: totalNum,
    loading: searchLoading
  }), React.createElement(SModal, {
    closeModal: closeModal,
    props: modalProps,
    visible: modalVisible
  }, modalChildren));
}
SPage.defaultProps = {
  filters: [],
  tableColumns: []
};