import "antd/es/table/style";
import _Table from "antd/es/table";
import "antd/es/card/style";
import _Card from "antd/es/card";

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import * as React from "react";
export default function STable(_a) {
  var _b = _a.tableData,
      tableData = _b === void 0 ? [] : _b,
      tableColumns = _a.tableColumns,
      _c = _a.tableProps,
      tableProps = _c === void 0 ? {} : _c,
      _d = _a.pageNum,
      pageNum = _d === void 0 ? 1 : _d,
      _e = _a.pageSize,
      pageSize = _e === void 0 ? 10 : _e,
      _f = _a.totalNum,
      totalNum = _f === void 0 ? 0 : _f,
      pageChange = _a.pageChange,
      loading = _a.loading;
  return React.createElement(_Card, {
    style: {
      marginTop: 20
    }
  }, React.createElement(_Table, __assign({
    loading: loading,
    rowKey: tableProps.rowKey,
    dataSource: tableData,
    columns: tableColumns,
    pagination: {
      current: pageNum,
      pageSize: pageSize,
      total: totalNum,
      onChange: pageChange,
      showTotal: function (total, range) {
        return range[0] + "-" + range[1] + " of " + total + " items";
      }
    }
  }, tableProps)));
}