import "antd/es/select/style";
import _Select from "antd/es/select";
import * as React from "react";
import { isArr, getOptionsArrByMap } from "../utils/tool";
export default function renderOptions(opts) {
  if (!isArr(opts)) opts = getOptionsArrByMap(opts);
  return opts.map(function (_a) {
    var label = _a.label,
        value = _a.value;
    return React.createElement(_Select.Option, {
      key: label,
      value: value
    }, label);
  });
}