import axios from "axios";
var instance = axios.create({
  withCredentials: true,
  headers: {
    "Content-Type": "application/json;charset=utf-8"
  }
});
instance.interceptors.response.use(function (response) {
  return response && response.data;
}, function (error) {
  return Promise.reject(error);
});
export default instance;