import * as React from "react";
import { Button, Input, Select, DatePicker } from "antd";
const { MonthPicker, WeekPicker, RangePicker } = DatePicker;

function Btn({ name, props, ...rest }: any) {
  return (
    <Button {...rest} {...props}>
      {name}
    </Button>
  );
}
export default {
  Button: Btn,
  Input: Input,
  Select: Select,
  MonthPicker: MonthPicker,
  WeekPicker: WeekPicker,
  RangePicker: (props: any) => <RangePicker showTime {...props} />
};
