import axios from "axios";
const instance = axios.create({
  withCredentials: true,
  headers: {
    "Content-Type": "application/json;charset=utf-8"
  }
});
instance.interceptors.response.use(
  (response: any) => {
    return response && response.data;
  },
  (error: any) => {
    return Promise.reject(error);
  }
);

export default instance;
