import "antd/es/select/style";
import _Select from "antd/es/select";
import "antd/es/input/style";
import _Input from "antd/es/input";
import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/date-picker/style";
import _DatePicker from "antd/es/date-picker";

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from "react";
var MonthPicker = _DatePicker.MonthPicker,
    WeekPicker = _DatePicker.WeekPicker,
    RangePicker = _DatePicker.RangePicker;

function Btn(_a) {
  var name = _a.name,
      props = _a.props,
      rest = __rest(_a, ["name", "props"]);

  return React.createElement(_Button, __assign({}, rest, props), name);
}

export default {
  Button: Btn,
  Input: _Input,
  Select: _Select,
  MonthPicker: MonthPicker,
  WeekPicker: WeekPicker,
  RangePicker: function (props) {
    return React.createElement(RangePicker, __assign({
      showTime: true
    }, props));
  }
};