import * as React from "react";
import { Modal } from "antd";
export default function ModalBtn({
  visible,
  children,
  props = {},
  closeModal
}: any) {
  return (
    <Modal
      footer={null}
      visible={visible}
      onCancel={closeModal}
      width={720}
      {...props}
    >
      {children}
    </Modal>
  );
}
